#include <3ds.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
u8* buffer;
int size=0;
int ret=0;

int main(int argc, char **argv){
	// Init
	srvInit(); aptInit(); hidInit(); csndInit();
	gfxInitDefault(); consoleInit(GFX_TOP, NULL);
	FILE *fp;
	if((fp=fopen("sdmc:/test.raw","rb"))!=NULL){
		fseek(fp,0,SEEK_END);
		size = ftell(fp);
		buffer = linearAlloc(size);
		fseek(fp,0,SEEK_SET);
		fread(buffer,1,size,fp);
		fclose(fp);
	}else printf("test.raw not found.\n");
	
	// Loop
	while (aptMainLoop()){
		hidScanInput();
		u32 kDown = hidKeysDown();
		if(kDown & KEY_A){
			ret = csndPlaySound(
				8, /* Đ`l */
				SOUND_FORMAT_16BIT | SOUND_REPEAT,  /* tH[}bg */
				48000, /* TvO[g */
				1.0f,  /* {[ ő1.0f */
				0.0f, /* p() -1.0f`+1.0f */
				buffer, /* TEhobt@w */
				buffer, /* [vubN */
				size); /* TEhobt@TCY */
			printf("%d ",ret);
		}
		if (kDown & KEY_START) break;
		GSPGPU_FlushDataCache(buffer, size);
		gfxFlushBuffers(); gfxSwapBuffers(); gspWaitForVBlank();
	}
	linearFree(buffer);
	CSND_SetPlayState(8, 0);
	csndExecCmds(true);
	gfxExit();
	return 0;
}
